# -*- coding: utf-8 -*-
"""
Created on Fri Sep 23 09:38:59 2016

@author: tm
"""


# bernoulli variable p_z is represented by a scalar, its mean (P(Z=1))

import pylab as pl
import numpy as np

from scipy.stats import norm, poisson

pl.close('all')

pl.figure('Bedingte Verteilung der Fallzahlen, 2 bedingende Merkmale')
ax = pl.subplot(111,projection='3d')

x = np.arange(5).reshape((1,5)) # birth order
y = np.arange(6).reshape((1,6)) # maternal age
#meshgrid transposes x and y
a, b = np.meshgrid(x,y)
z = 10 ** (b/5)
zr  = z.copy()                  # cases per 1000
for i in np.arange(6):
    zr[i,:]  += np.random.normal(0, np.sqrt(zr[i,0])/5, size=5)



ax.bar3d(a.flatten(), b.flatten(), np.zeros(a.size),0.5 *np.ones_like(a.size), 0.5*np.ones_like(b.size),zr.flatten(), shade=True)
ax.set_xlabel('x - Geburtsrang')
ax.set_ylabel('y - Alter der Mutter')
ax.set_zlabel('z - Fälle pro 1000 Geburten')

p_z_xy = zr.T/1000

#<20, 20-24,25-29, 30-34, 35-39, 40+
birth_count_austria_2005 = np.array([('<20', 3064), ('20-24',14395),
                                    ('25-29',23804),('30-34',23271),('35-39',11414),
                                    ('40+',2244)],dtype=[('age class', 'U10'),('age','i4')])


mat_uk_2019 = np.loadtxt('D:\work\sme\datasets\maternal_age.prn').T

tmp = np.asarray(mat_uk_2019.shape)
tmp[1] -= 1
p_xy= np.zeros(shape=tmp)
p_xy[:,:]=mat_uk_2019[:,:-1]
p_xy[:,-1]+=mat_uk_2019[:,-1]
p_xy /= p_xy.sum()

p_x = p_xy.sum(axis=1)
p_y = p_xy.sum(axis=0)


p_x_y = p_xy / p_y
p_y_x = p_xy.T / p_x

p_zxy = p_z_xy * p_xy
p_z = p_zxy.sum()
p_zx =  p_zxy.sum(axis=1)
p_z_x = p_zx/p_x
p_zy = p_zxy.sum(axis=0)
p_z_y = p_zy/p_y

m_x = p_x.dot(np.arange(len(p_x)))
m_y = p_y.dot(np.arange(len(p_y)))
m_z = p_z

pl.figure('Bedingte Verteilung der Fallzahlen, 1 bedingendes Merkmal')
ax1 = pl.subplot(121)
ax1.plot(np.arange(5),p_z_x * 1000, '*')
ax1.set_xlabel('Geburtsrang')
ax1.set_ylabel('Fälle pro 1000 Geburten')

ax2 = pl.subplot(122, sharey = ax1)
ax2.plot(np.arange(6),p_z_y * 1000, '*')
ax2.set_xlabel('Alter der Mutter')


CM = np.zeros((3,3)) #order: zxy

CM[0,0]= p_z * (1-p_z)
CM[0,1] =p_zx.dot(np.arange(len(p_x))) - m_z* m_x  
CM[0,2] =p_zy.dot(np.arange(len(p_y))) - m_z* m_y
CM[1,1] =p_x.dot(np.arange(len(p_x))**2) - m_x**2
CM[2,2] =p_y.dot(np.arange(len(p_y))**2) - m_y**2
CM[1,2] = (x.T.dot(y) * p_xy).sum() - m_x * m_y

CM[1,0] = CM[0,1]
CM[2,0] = CM[0,2]
CM[2,1] = CM[1,2]
tmp = np.sqrt(np.diag(1/CM.diagonal()))
CorrM = tmp.dot(CM).dot(tmp)



#partial correlation (for y fixed)

tmp = CM[:-1,2].reshape((2,1))
CP = CM[:-1,:-1] - tmp.dot(tmp.T)/CM[2,2]
tmp = np.sqrt(np.diag(1/CP.diagonal()))
CorrP = tmp.dot(CP).dot(tmp)

# with wikipedia formula (partial correlation), should equal CorrP[0,1]
c = CorrM
pc2 = (c[0,1] - c[0,2]*c[1,2])/np.sqrt((1-c[0,2]**2)*(1-c[1,2]**2))


# full regression (maternal age + birth order)
tmp = np.linalg.pinv(CM[1:,1:])
w_bm = CM[0,1:].dot(tmp)

# regression (birth order only)
tmp = 1/CM[1,1]
w_b = CM[0,1]*tmp 


